/* 
* Version 0.8 - 2016.04.02
*
* Generate all permutations of S_n (in lexicographic order)
* Each permutation is represented by an array of integers called p
* The basic method of construction is GenLex(n)
*/

public class Permutations{
    
    public static void main(String[] args)
    {
        int n = 4; //choose which S_n to generate
	GenLex(n);
    }
    
    //
    //  GenLex(int n):
    //  Generates all permutations of S_n in lexicographic order  
    //  Permutations are not stored, they are just printed as they
    //    get generated
    //
    public static void GenLex(int n){
    	int[] p = new int[n]; //p stores the current permutation
	
	// Create the minimum/first permutation of S_n
    	for(int j=0; j<p.length; j++)
	{
            p[j]=j+1;
        }
	
	while(true)
	{
		// print the current permutation p
		for(int j=0;j<p.length;j++)
		{
			System.out.print(p[j]+" ");
		}
		System.out.println("");
	
		// Compute the next permutation after p
	
		// Find the last ascent of p 
		// reading p backwards	
		
		// ascpos stores the position of the last ascent
        	int ascpos = -1; 
		
		for(int j=p.length-1; j>=1; j--)
		{
            		if(p[j]>p[j-1])
			//the last ascent is found!
			{
                		ascpos = j-1;
                		break;
            		}
        	}

		if(ascpos==-1)
		{ 
		// ascpos=-1 means that p contains no ascent at all 
		// i.e. we reached the maximum/last element of S_n
		// we should break while
			break; 
		}
	
		for(int k=p.length-1; k>=ascpos+1;k--){
			// find the minimum element p[k] of p
			// that is greater than p[ascpos] 
			// and after p[ascpos]
			if(p[k]>p[ascpos])
			{
				//swap p[ascpos] and p[k]
				int temp = p[k];
				p[k] = p[ascpos];
				p[ascpos] = temp;
				
				//reverse all elements of p
				//after p[ascpos] by swaping 
				//elements symmetrically
				for(int j=0; j<=((p.length-1)-(ascpos+1))/2; j++)
				{
                			temp = p[ascpos+1+j];
					p[ascpos+1+j] = p[p.length-1-j];
					p[p.length-1-j] = temp;
				}
				break;
            		}
        	}
		
	
	}
    }
    
    
}

